# Handlers execute in the order they are defined
# https://docs.ansible.com/ansible/latest/reference_appendices/glossary.html#notify
# We want the service to run before the registration occurs, if both are required 
- name: gitlab-runner service
  systemd:
    name: gitlab-runner.service
    daemon_reload: yes
    state: restarted
    enabled: yes
  become: yes

- name: gitlab-runner unregister
  command: gitlab-runner unregister --all-runners
  become: yes

- name: gitlab-runner register
  command: gitlab-runner register >
    --non-interactive
    --name '{{ gitlab_runner_name }}'
    --url '{{ gitlab_url }}'
    --registration-token '{{ gitlab_token }}'
    --tag-list '{{ gitlab_runner_tags }}'
    --executor 'docker+machine'
    --limit '{{ num_runners }}'
    --docker-image 'alpine'
    --docker-privileged
    --machine-idle-nodes '0'
    --machine-idle-time '300'
    --machine-machine-driver 'google'
    --machine-machine-name 'auto-scale-runner-%s'
    --machine-machine-options 'google-project={{ gcp_project }}'
    --machine-machine-options 'google-machine-type={{ gcp_machine_type }}'
    --machine-machine-options 'google-machine-image=coreos-cloud/global/images/family/coreos-stable'
    --machine-machine-options 'google-tags=gitlab-ci-slave'
    --machine-machine-options 'google-disk-type={{ gcp_disk_type }}'
    --machine-machine-options 'google-disk-size={{ gcp_disk_size }}'
    --machine-machine-options 'google-preemptible=true'
    --machine-machine-options 'google-zone={{ gcp_zone }}'
    --machine-machine-options 'google-use-internal-ip=true'
  become: yes

- name: gitlab-runner-arm register
  command: gitlab-runner register >
    --non-interactive
    --name '{{ gitlab_runner_name }}'
    --url '{{ gitlab_url }}'
    --registration-token '{{ gitlab_token }}'
    --tag-list '{{ gitlab_runner_tags }}'
    --executor 'docker'
    --limit '{{ num_runners }}'
    --docker-image 'alpine'
    --docker-privileged
    --machine-idle-nodes '0'
    --machine-idle-time '300'
  become: yes
